using Itrycn_Project2;
using ryCommon;
using ryCommonDb;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Itrycn_Project2
{
    public partial class FrmStart : RySkins.SKinForm
    {
        readonly string[] prog_args;
        public FrmStart(string[] args)
        {
            InitializeComponent();
            prog_args = args;
            //配置软件信息
            notifyIcon1.Text = Soft_ConstInfo.Soft_Title;
            Text = Soft_ConstInfo.Soft_Title + " V" + RySoft.VersionStr;
            if (!Soft_ConstInfo.ShowTray) { notifyIcon1.Visible = false; }
            if (!Soft_ConstInfo.DonateVisabled) { 捐助ToolStripMenuItem.Text = "关于"; }
            if (Soft_ConstInfo.Soft_Url.Length == 0) { 打开官网ToolStripMenuItem.PerformClick(); }
            notifyIcon1.Icon = Icon;
        }

        private void 显示主窗体ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.WindowState = FormWindowState.Normal;
            var topmost = this.TopMost;
            this.TopMost = true;
            this.Show();
            this.TopMost = topmost;
        }

        private void 退出软件ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void FrmStart_Shown(object sender, EventArgs e)
        {
            ryCommon.Ini ini = new Ini(Soft_ConstInfo.UserDataFolder + "\\Win.dat");
            ini.WriteIni(Soft_ConstInfo.Soft_Id, "hwnd", Handle.ToInt32());
            if (prog_args.Length >= 1)
            {
                //如果是自启动,并且开启了右下角托盘图标,则隐藏自身。
                if (prog_args[0] == Soft_ConstInfo.Soft_Pram && Soft_ConstInfo.ShowTray)
                    this.Hide();
            }
        }

        private void FrmStart_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (Soft_ConstInfo.ShowTray && Public_Config.HideByCloseBtn && e.CloseReason== CloseReason.UserClosing)
            {
                e.Cancel = true;
                this.Hide();
                notifyIcon1.ShowBalloonTip(3000, Soft_ConstInfo.Soft_Title, "软件已经最小化到此处,请右击托盘图标进行关闭。", ToolTipIcon.Info);
                return;
            }
            if (!Soft_MemInfo.IsCanCloseForm)
            {
                e.Cancel = true;
                RySkins.Msg.ShowMsg("当前还有操作正在运行,请稍后关闭软件。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
        protected override void WndProc(ref System.Windows.Forms.Message msg)
        {
            switch (msg.Msg)
            {
                case 17189: //处理消息
                    {
                        #region 激活窗体
                        switch (msg.WParam.ToInt32())
                        {
                            case 100://
                                #region 显示界面
                                if ((int)msg.LParam.ToInt32() == 100)
                                {
                                    this.Show();
                                    this.WindowState = FormWindowState.Normal;
                                    this.Top = (Screen.PrimaryScreen.WorkingArea.Height - this.Height) / 2;
                                    this.Left = (Screen.PrimaryScreen.WorkingArea.Width - this.Width) / 2;
                                    //RyForm.SetActiveWindow(Handle);
                                    RyForm.BringToTop(Handle);
                                    显示主窗体ToolStripMenuItem.PerformClick();
                                    this.BringToFront();
                                    this.Select();
                                    this.Focus();
                                    RyForm.BringToTop(Handle);
                                }
                                #endregion
                                break;
                        }
                        #endregion
                    }
                    break;
                default:
                    base.WndProc(ref msg);//调用基类函数处理非自定义消息。
                    break;
            }
        }

        private void 捐助ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (Soft_ConstInfo.DonateVisabled)
            {
                FrmAbout frm = new FrmAbout();
                frm.ShowDialog();
                frm.Dispose();
            }
            else
            {

                RySkins.Msg.ShowMsg(Soft_ConstInfo.AboutText.Replace("#softname#", Soft_ConstInfo.Soft_Title).Replace("#ver#", "V" + RySoft.VersionStr), "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }


        private void 打开官网ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ryCommon.RyFiles.OpenUrl(Soft_ConstInfo.Soft_Url);
        }

        private void FrmStart_Load(object sender, EventArgs e)
        {
            Public_Config.LoadSetting();
            RyFiles.AddDropDrag(tabPage1.Handle);
            //Itrycn_Project.Itrycn_Db.CreateTable();
            //var dbver = Itrycn_Db.GetDbVer();
            //if(dbver==1) //初始版本,并是当前要求的数据库
            //{

            //}
            //else
            //{
            //    MessageBox.Show("不支持当前数据库版本,这可能是以下原因导致的:\r\n1.数据库已损坏;'\r\n2.当前数据库是由新版软件创建的(请更新软件后重试)。", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
            //    Application.Exit();
            //    return;
            //}
            //IDbInterface db = new SQLiteDataProvider();
            //if (db.ConnDb(@"E:\My Datas\毕方项目\C#\ryProcessManager\Bin\Debug\UserDb\MyDb.dat|ry3H3Db") == 1)
            //{
            //}
            //db.Free();
            LiveUpdate.RyUpdate update = new LiveUpdate.RyUpdate(Soft_ConstInfo.Update_Url);
            update.CheckUpdate();
            var http = new DotNet4.Utilities.HttpHelper();
            var item = new DotNet4.Utilities.HttpItem
            {
                URL = "http://www.huaan.cn/api/applet/qrcode/queryComponent",
                Method = "POST",
                IsToLower = false,
                Postdata = "{\"tempId\":1619,\"excludeVisibility\":4,\"status\":1,\"valueStatus\":1,\"visibleAndEditableUserId\":3}",
                ContentType = "application/json",
                ProtocolVersion = System.Net.HttpVersion.Version11,
                ProxyIp = "192.168.1.12"
            };
            var r= http.GetHtml(item);
        }

        private void 选项ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            FrmSetting frm = new FrmSetting();
            if(frm.ShowDialog()==DialogResult.OK)
            {
                Public_Config.LoadSetting();
            }
            frm.Dispose();
        }
    }
}
